var REST = {

    url: '*** YOUR SMB SERVER ADDRESS URL ***',

    authcode: null,

    sendToken: async function( token = null, bagid = null ) {

        return new Promise( (resolve, reject)  => {

            if (bagid == null) {
                var csmb = app.currentSMB()
                if (csmb) bagid = 'SMB-'+csmb.sn;
                else {
                    reject('Send token: No active SMB')
                    return
                }
            }

            if (REST.authcode == null) {
                // try to set from current SMB //

                let currentsmb = app.currentSMB();
                if (!currentsmb) {
                    reject('Send token: auth code unset')
                    return
                }

                let csmb = app.smbList.get(currentsmb.sn,currentsmb.addr)
                if (csmb) {
                    REST.authcode = csmb.client_key
                } else {
                    reject('Send token: auth code unset')
                    return
                }
            }

            if (REST.authcode == null || REST.authcode == '') {
                reject('Send token: auth code unset')
                return
            }

            var requestURL = REST.url + '/'+bagid+'/notify/register'

            if (token == null) {
                token = app.db.getItem('fcmtoken')
            }

            if (token == null) {
                reject('Send token: token is null')
                return
            }

            var data = {
                ver: 1000,
                data: {
                    os: String(device.platform).toLowerCase(),
                    key: token
                }
            }

            $.ajax({
                url: requestURL,
                type: 'PUT',
    			data: JSON.stringify(data),
                dataType: 'json',
                headers: { 'x-smb-auth-token': REST.authcode },
                contentType: 'application/json',
                success: (result) => {
                    resolve(result);
                },
                error: (error) => {
                    reject(error);
                }
            });

        });


    }


}
