'use strict';

class AlertDataModel {
	constructor(rawData) {
		this._defaultData();
		if (rawData) {
			this.parseData(rawData);
		}
	}

	parseData(rawData) {
		this._defaultData();
		this._setRecordIfPresent("no_phone", rawData);
		this._setRecordIfPresent("missing_gadget", rawData);
		this._setRecordIfPresent("low_battery", rawData);
	}

	alertIfNoPhone() {
		return this._record.no_phone;
	}

	alertIfMissingGadget() {
		return this._record.missing_gadget;
	}

	alertIfLowBattery() {
		return this._record.low_battery;
	}


	getData() {
		return {...this._record};
	}

	_defaultData() {
		this._record = {
			no_phone       : false,
			missing_gadget : false,
			low_battery	   : false
		}
	}

	validate() {
		if (Object.keys(this._record).length === 0) {
			return "Data is empty";
		}

		return true;
	}

	_setRecordIfPresent(key, rawData) {
		if (rawData[key] !== undefined) {
			this._record[key] = rawData[key];
		}
	}
}

module.exports = AlertDataModel;