'use strict';

class DataLayerException extends Error {
	constructor(message, code, fileName, lineNumber) {
		super(message, fileName, lineNumber);
		this._code    = code;
		this._message = message;
	}

	getErrorCode() {
		return this._code;
	}
}

DataLayerException.ERROR_NOT_CONNECTED = 1;
DataLayerException.ERROR_UNKNOWN_KEY_NAME = 2;
DataLayerException.ERROR_MISSING_KEY = 3;

module.exports = DataLayerException;