'use strict';
const CONST = require("../constants.js");
const LOG   = require("./Logger.js");

class CacheBase {
	has(id) {
		throw new Error("Cache implementation must implement method 'has'!");
	}

	get(id, def) {
		throw new Error("Cache implementation must implement method 'get'!");
	}

	add(id, item) {
		throw new Error("Cache implementation must implement method 'add'!");
	}

	remove(id) {
		throw new Error("Cache implementation must implement method 'remove'!");
	}

	clear() {
		this.each((key, data) => this.remove(key));
	}

	each(cb) {
		throw new Error("Cache implementation must implement method 'each'!");
	}
}

module.exports = CacheBase;