'use strict';

class StorageLayerException extends Error {
	constructor(message, code, fileName, lineNumber) {
		super(message, fileName, lineNumber);
		this._code    = code || 0;
		this._message = message;
	}

	getErrorCode() {
		return this._code;
	}
}

StorageLayerException.ERROR_NOT_FOUND           = 1;
StorageLayerException.ERROR_PERMISSION_DENIED   = 2;
StorageLayerException.ERROR_ALREADY_EXIST       = 3;
StorageLayerException.ERROR_NOT_EMPTY           = 4;
StorageLayerException.ERROR_NOT_A_FILE          = 5;
StorageLayerException.ERROR_NOT_A_DIRECTORY     = 6;
StorageLayerException.ERROR_BROKEN_PIPE         = 7;
StorageLayerException.ERROR_TOO_MANY_OPEN_FILES = 8;

module.exports = StorageLayerException;
