'use strict'

class Client {
	constructor(me, partner) {
		this._socket = new WebSocket("ws://localhost:1337");
		this._me     = me;
		this._partner = partner;

		this._socket.onopen = e => {
			this.send({
				type : "open",
				me   : this._me,
				rec  : this._partner,
				seq  : 5
			});
		}

		this._socket.onerror = e => console.log(this._me, "Error", e);
		this._socket.onclose = e => console.log(this._me, "Close", e);
		this._socket.onmessage = e => console.log(this._me, "Message", e.data);
	}

	send(msg) {
		this._socket.send(JSON.stringify(msg));
	}

	close() {
		this._socket.close();
	}
}

let c1 = new Client("asdfgas-1", "asdfgas-2");
let c2 = new Client("asdfgas-2", "asdfgas-1");

setTimeout(() => {
	c1.send({
		type : "send",
		d    : "HELLO",
		seq  : 12
	})
}, 500)


setTimeout(() => {
	c1.close();
}, 1000)


setTimeout(() => {
	c1 = new Client("asdfgas-1", "asdfgas-2");
}, 1500)

setTimeout(() => {
	c1.send({
		type : "send",
		d    : "BACK",
		seq  : 12
	})
}, 2000)

