'use strict';
const crypto = require('crypto');

class Crypto {
	constructor(cryptoKey, tokenEncoding) {
		this._cryptoKey = cryptoKey;
		this._tokenEncoding = tokenEncoding || "hex";
	}

	encrypt(string) {
		let cipher   = crypto.createCipher("aes256", this._cryptoKey);
		return cipher.update(string, "utf8", this._tokenEncoding) + cipher.final(this._tokenEncoding);
	}

	decrypt(string) {
		try {
			let decipher = crypto.createDecipher("aes256", this._cryptoKey);
			return decipher.update(string, this._tokenEncoding, "utf8") + decipher.final("utf8");
		} catch (e) {
			return null;
		}
	}
}

module.exports = Crypto;