const Util = require("../Util/Util.js");
const SmbfwActions = {};

SmbfwActions.changeScreen = function(screen, screenParams) {
	let ret = {
		type    : SmbfwActions.changeScreen.type,
		payload : screen
	}

	if (screenParams) {
		ret.screenParams = screenParams;
	}
	return ret;
}
SmbfwActions.changeScreen.type = "smbfw.services.screen.changeScreen";

SmbfwActions.showModal = function(modalwindow, modalParams) {
	let ret = {
		type    : SmbfwActions.showModal.type,
		payload : modalwindow
	}

	if (modalParams) {
		ret.modalParams = modalParams;
	}
	return ret;
}
SmbfwActions.showModal.type = "smbfw.services.screen.showModal";

SmbfwActions.hideModal = function() {
	return {
		type    : SmbfwActions.hideModal.type,
		payload : null
	};
}
SmbfwActions.hideModal.type = "smbfw.services.screen.hideModal";

SmbfwActions.updateScreenAvailability = function(availability) {
	return {
		type    : SmbfwActions.updateScreenAvailability.type,
		payload : availability
	};
}
SmbfwActions.updateScreenAvailability.type = "smbfw.services.screen.updateScreenAvailability";

SmbfwActions.setScreenDeeplinking = function(screen, params) {
	let ret = {
		type    : SmbfwActions.setScreenDeeplinking.type,
		payload : screen
	}

	if (params) {
		ret.params = params;
	}
	return ret;
}
SmbfwActions.setScreenDeeplinking.type = "smbfw.services.screen.setScreenDeeplinking";

SmbfwActions.updateState = function(stateChanges) {
	return {
		type    : SmbfwActions.updateState.type,
		payload : {
			changeList  : stateChanges,
			changeTree  : Util.generateStateChangeTree(stateChanges)
		}
	}
}
SmbfwActions.updateState.type = "smbfw.reducer.updateState";

SmbfwActions.closeSnack = function() {
	return SmbfwActions.updateState({
		"smbfw.snack" : {
			open : false
		}
	})
}
SmbfwActions.updateState.type = "smbfw.reducer.closeSnack";

SmbfwActions.openSnack = function(message, type) {
	return SmbfwActions.updateState({
		"smbfw.snack" : {
			open : true,
			message : message,
			type    : type || "Success"
		}
	})
}
SmbfwActions.updateState.type = "smbfw.reducer.closeSnack";

SmbfwActions.changeMainCSS = function(css) {
	return {
		type    : SmbfwActions.changeMainCSS.type,
		payload : css
	}
}
SmbfwActions.changeMainCSS.type = "smbfw.services.service.changeMainCSS";

SmbfwActions.fetchDataToStore = function(dataSource, key, storePath) {
	return {
		type    : SmbfwActions.fetchDataToStore.type,
		payload : {
			dataSource : dataSource,
			key        : key,
			storePath  : storePath
		}
	}
}
SmbfwActions.fetchDataToStore.type = "smbfw.services.service.fetchDataToStore";

SmbfwActions.increaseLock = function(lock) {
	return {
		type    : SmbfwActions.increaseLock.type,
		payload : lock,
		default : 1,
		amount  : 1
	}
}
SmbfwActions.increaseLock.type = "smbfw.reducer.increaseLock";

SmbfwActions.decreaseLock = function(lock) {
	return {
		type    : SmbfwActions.decreaseLock.type,
		payload : lock,
		default : 0,
		amount  : -1
	}
}
SmbfwActions.decreaseLock.type = "smbfw.reducer.decreaseLock";

for (let i in SmbfwActions) {
	SmbfwActions[i].match = function(action) {
		return this.type === action.type;
	}
}

module.exports = SmbfwActions;