'use strict';

class RESTHeaderAppender {
	constructor(headers) {
		this._headers = headers;
	}

	_prepareOptions(options, method, path) {
		if (!options) options = {};
		options.headers = {
			...this._headers,
			...(options.headers || {})
		}
		return options;
	}

	preSaveData(id, data, options) {
		return [id, data, this._prepareOptions(options)];
	}

	preLoadData(id, options) {
		return [id, this._prepareOptions(options)];
	}

	preCreateData(data, options) {
		return [data, this._prepareOptions(options)];
	}

	postSaveData(id, data, options) {
		return [id, data, this._prepareOptions(options)];
	}

	postLoadData(id, data, options) {
		return [id, data, this._prepareOptions(options)];
	}

	postCreateData(id, data, options) {
		return [id, data, this._prepareOptions(options)];
	}
}

module.exports = RESTHeaderAppender;
