'use strict';

var exceptions = {};

function addException(cls) {
	exceptions[cls.name] = cls;
}

addException(class SmbfwException extends Error {
	constructor(message, code, type, data) {
		super(message)
		this._code = code || "";
		this._type = type || "";
		this._data = data || {};
	}

	getCode() {
		return this._code;
	}

	getType() {
		return this._type;
	}

	getData() {
		return this._data;
	}
});

addException(class InvalidStateException extends exceptions.SmbfwException {
	constructor(...args) {
		super(...args)
	}
});

addException(class InvalidStateChangeException extends exceptions.SmbfwException {
	constructor(...args) {
		super(...args)
	}
});

addException(class InvalidArgumentException extends exceptions.SmbfwException {
	constructor(...args) {
		super(...args)
	}
});

addException(class UnimplementedMethodException extends exceptions.SmbfwException {
	constructor(...args) {
		super(...args)
	}
});

addException(class MissingFieldException extends exceptions.SmbfwException {
	constructor(...args) {
		super(...args)
	}
});

addException(class PromiseError extends exceptions.SmbfwException {
	constructor(...args) {
		super(...args)
	}
});


module.exports = exceptions;