'use strict';
const ManagerBase       = require("./ManagerBase.js");
const BusinessLogicBase = require("../BusinessLogic/BusinessLogicBase.js");

const {
	InvalidStateException,
	InvalidArgumentException,
	InvalidStateChangeException
} = require('../Exception/Exceptions.js');

class BusinessLogicManager extends ManagerBase {
	businessLogicActionHandler(action, next, state) {
		let parts = action.type.split(".");

		if (parts[2]) {
			let bl = this._getManaged(parts[2]);

			if (bl) bl.handle(action, state, this._dispatch);
		}
	}

	registerBusinessLogic() {
		for (let i = 0; i < arguments.length; i++) {
			this._addManaged(arguments[i]);
		}
	}
}

BusinessLogicManager.prototype.PUBLISHED_METHODS  = ["registerBusinessLogic"];
BusinessLogicManager.prototype.MANAGED_BASE_CLASS = BusinessLogicBase;
module.exports = BusinessLogicManager;