'use strict';
const ManagerBase = require("./ManagerBase.js");
const Localizer   = require('../Util/Localizer.js');
const {InvalidArgumentException} = require('../Exception/Exceptions.js');

class LocalizationManager extends ManagerBase {
	constructor() {
		super();
		this._localizer = new Localizer();
	}

	setLocalizationData(ldata) {
		this._localizer.setLocalizationData(ldata);
	}

	setLocale(locale) {
		this._localizer.setLocale(locale);
	}

	getLocale() {
		return this._localizer.getLocale();
	}

	hasLocale(locale) {
		return this._localizer.hasLocale(locale);
	}

	localize(key, ...params) {
		return this._localizer.localize(key, ...params);
	}
}

LocalizationManager.prototype.PUBLISHED_METHODS = ["setLocalizationData", "localize", "setLocale", "getLocale", "hasLocale"];


module.exports = LocalizationManager;