"use strict";
const BusinessLogicBase = require("../../smbfw/src/smbfw.js").BusinessLogicBase;
const SmbfwActions      = require("../../smbfw/src/smbfw.js").Actions;

class NavBarBL extends BusinessLogicBase {
	openProfileScreen(state, dispatch) {
		dispatch(SmbfwActions.changeScreen("profile_screen"));
	}

	openNotificationConfigScreen(state, dispatch) {
		dispatch(SmbfwActions.changeScreen("NotificationConfigScreen"));
	}

	openForgottenPasswordScreen(state, dispatch) {
		dispatch(SmbfwActions.changeScreen("ForgottenPasswordScreen"));
	}

	openRegistrationScreen(state, dispatch) {
		dispatch(SmbfwActions.changeScreen("registration_screen"));
	}

	openDashboardScreen(state, dispatch) {
		dispatch(SmbfwActions.changeScreen("DashboardScreen"));
	}

	openTrackBagScreen(state, dispatch) {
		dispatch(SmbfwActions.changeScreen("TrackBagScreen"));
	}

	openLoginScreen(state, dispatch) {
		dispatch(SmbfwActions.changeScreen("login_screen"));
	}

	logout(state, dispatch) {
		document.cookie = "smbuiauth=; expires=Thu, 01 Jan 1970 00:00:00 UTC; path=/;";
		dispatch(SmbfwActions.changeScreen("login_screen"));
	}


}
NavBarBL.prototype.MANAGED_NAME = "nav_bar_bl";

BusinessLogicBase.generateActions(NavBarBL, {
	"openProfileScreen" : "openProfileScreen",
	"openNotificationConfigScreen" : "openNotificationConfigScreen",
	"openForgottenPasswordScreen" : "openForgottenPasswordScreen",
	"openRegistrationScreen" : "openRegistrationScreen",
	"openDashboardScreen" : "openDashboardScreen",
	"openTrackBagScreen" : "openTrackBagScreen",
	"openLoginScreen" : "openLoginScreen",
	"logout" : "logout"
});

module.exports = NavBarBL;
