"use strict";
const BusinessLogicBase = require("../../smbfw/src/smbfw.js").BusinessLogicBase;
const SmbfwActions      = require("../../smbfw/src/smbfw.js").Actions;

class RegistrationScreenBL extends BusinessLogicBase {
	handleRegister(state, dispatch, email, password, name, bagId, clientToken)	{
		let user = this._smbfw.dm.createData("register");
		dispatch(SmbfwActions.increaseLock("full"));
		user
			.setName(name)
			.setPassword(password)
			.setEmail(email)
			.setBagId(bagId)
			.setClientToken(clientToken)
			.save()
			.then(e => {
				dispatch(SmbfwActions.openSnack(this._smbfw.l.localize("success.register"), "Success"));
			})
			.catch(e => {
				dispatch(SmbfwActions.openSnack(this._smbfw.l.localize("error.register"), "Error"));
				this._error(e);
			})
			.then(r => {
				dispatch(SmbfwActions.decreaseLock("full"));
			})
	}
}

RegistrationScreenBL.prototype.MANAGED_NAME = "registration_screen_bl";

BusinessLogicBase.generateActions(RegistrationScreenBL, {
	actionRegister : "handleRegister"
});

module.exports = RegistrationScreenBL;
