import React from "react";
import GoogleMapReact from 'google-map-react';

const MapMarker     = require("./MapMarker.jsx").default;
export const TrackingMap = props => {
	let $_l = props.$_l;
	let lat = (("" + props.lat).replace(",", ".") * 1) || 0;
	let lon = (("" + props.lon).replace(",", ".") * 1) || 0;
	return (
		<div style={{width: props.width || 600, height: props.height || 600}}>
			<GoogleMapReact
				bootstrapURLKeys={{ key: "AIzaSyD93_F-DaBOLijrmoJU_NXJc9NVN6X9YIE" }}
				center={{
					lat: lat,
					lng: lon
				}}
				defaultZoom={props.zoom || 15}>
				<MapMarker
					lat={lat}
					lng={lon}
					text={props.text}
				/>
			</GoogleMapReact>
		</div>
	);
};

export default TrackingMap;