const React     = require("react");
const connect   = require("../../../smbfw/src/smbfw.js").connect;
const LayoutScreenBase     = require("./LayoutScreenBase.jsx").default;
const ForgottenPasswordScreenActions = require("../../businessLogic/ForgottenPasswordScreenBL.js").Actions;

import TextField from '@material-ui/core/TextField';
import Button from '@material-ui/core/Button';
import Paper from '@material-ui/core/Paper';
import Typography from '@material-ui/core/Typography';
import BusinessCenterIcon from '@material-ui/icons/BusinessCenter';
import AppBar from '@material-ui/core/AppBar';
import Toolbar from '@material-ui/core/Toolbar';


class ForgottenPasswordScreen extends React.Component {
	constructor(props) {
		super(props);
		this.state = {
		};
	}

	_genericStateUpdate(event) {
		this.setState({ [event.target.name]: event.target.value });
	}

	_renderField(name, type) {
		return (<TextField
			name={name}
			label={this.props.$_l("screen.forgotten_password." + name)}
			style={{width: "100%"}}
			defaultValue={this.state[name]}
			onChange={e => this._genericStateUpdate(e)}
			type={type || "text" }
		/>)
	}

	render() {
		let $_l = this.props.$_l;
		return (
			<div>
				<AppBar>
					<Toolbar>
						<BusinessCenterIcon style={{marginRight: "12px", fontSize: 42}}/>
						<Typography variant="h6" style={{flexGrow: 1}}>
							SMB Web Admin
						</Typography>
					</Toolbar>
				</AppBar>
				<Paper className="form" style={{
					margin: "102px auto 20px auto",
					width: "60%",
					padding: "20px",
				}}>
					<Typography variant="h3" component="h2" style={{marginBottom : "20px"}}>
						{$_l("screen.forgotten_password.title")}
					</Typography>
					<Typography variant="body1" style={{marginBottom : "20px"}}>
						{$_l("screen.forgotten_password.info")}
					</Typography>
					{this._renderField("email")}
					{this._renderField("bagId")}
					<div style={{justifyContent: "flex-end", display: "flex"}}>
						<Button variant="contained"
							color="secondary"
							style={{marginTop : "40px"}}
							onClick={() =>this.props.openLoginScreen()}
						>
							{$_l("shared.cancel")}
						</Button>
						<div style={{flexGrow: 1}}></div>
						<Button variant="contained"
							color="primary"
							style={{
								marginTop : "40px"
							}}
							onClick={() => this.props.actionReset(this.state.email, this.state.bagId)}
						>
							{$_l("screen.forgotten_password.reset")}
						</Button>
					</div>
				</Paper>
			</div>
		);
	}
}

const mapStateToProps = state => ({
	...(LayoutScreenBase.getStateToProps(state))
});

const mapDispatchToProps = ForgottenPasswordScreenActions.toMapDispatchToProps({
	...(LayoutScreenBase.getDispatchToProps())
});

export default connect(
	mapStateToProps,
	mapDispatchToProps
)(ForgottenPasswordScreen);
