"use strict";
const Smbfw   = require("../../smbfw/src/smbfw.js");

class AuthenticateRDM extends Smbfw.RESTModelBase {
	/***
	 * This method is invoked when no data is provided, and we need to initialize an empty object
	 * @return {mixed} - Initial data in internal format
	 */
	_initialData() {
		return {
			email    : null,
			password : null,
		};
	}

	setAuthParams(email, password) {
		this._data.email    = email;
		this._data.password = password;
	}

	getUserId() {
		return this._data.uid;
	}

	updateRawData(data) {
		this._data = this._parseData(data);
		this._afterParseData();
	}
}

module.exports = AuthenticateRDM;