"use strict";
const Smbfw   = require("../../smbfw/src/smbfw.js");

class NotificationConfigRDM extends Smbfw.RESTModelBase {
	/***
	 * This method is invoked when no data is provided, and we need to initialize an empty object
	 * @return {mixed} - Initial data in internal format
	 */
	_initialData() {
		return {
			no_phone       : false,
			missing_gadget : false,
			low_battery    : false
		};
	}

	constructor(...args) {
		super(...args);
		this._create = false;
	}

	setNotificationConfig(no_phone, missing_gadget, low_battery) {
		this._data.no_phone       = no_phone;
		this._data.missing_gadget = missing_gadget;
		this._data.low_battery    = low_battery;
		return this;
	}

	get(key) {
		return this._data[key];
	}
}

module.exports = NotificationConfigRDM;