/*
  This is just a skeleton file, to show a proof of concept for middlewares.
  Middlewares can implement preMETHODs and postMETHODs where the METHOD is the actual method called on the pipe.
  The corresponding preMETHOD will be invoked with all the arguments to be passed to the provider, and is expected to return all arguments in an array
  in the same order as received. Middlewares are allowed to modify the arguments, actually this is their purpose.

  The skeleton below is a transparend middlware which just passes on the arguments. It is for demonstration purposes only, and it is not recommended.

  If a method is not to be handled my a middleware, simply don't implement the method, and it will be skipped in the middleware chain.
*/

module.exports = {
	preSaveData : function(id, data, options) {
		return [id, data, options];
	}

	preLoadData : function(id, options) {
		return [id, options];
	}

	preCreateData : function(data, options) {
		return [data, options];
	}

	preListData : function(filter, options) {
		return [filter, options];
	}

	preContinueList : function(token) {
		return [token];
	}

	postSaveData : function(id, data, options) {
		return [id, data, options];
	}

	postLoadData : function(id, data, options) {
		return [id, data, options];
	}

	postCreateData : function(id, data, options) {
		return [id, data, options];
	}

	postListData : function(filter, options) {
		return [filter, options];
	}

	postContinueList : function(data, token) {
		return [data, token];
	}
}